﻿Public Class Form1
    Private Declare Sub SetGen Lib "FGULink.dll " (ByVal func As Integer, ByVal freq As Single, ByVal ampl As Single, ByVal offset As Single)
    Private Declare Sub SetSweep Lib "FGULink.dll " (ByVal freq1 As Single, ByVal freq2 As Single, ByVal ampl As Single, ByVal offset As Single, ByVal time As Single, ByVal Form As Integer)
    Private Declare Sub SetLibWave Lib "FGULink.dll " (ByVal freq As Single, ByVal ampl As Single, ByVal offset As Single, ByVal filter As Integer, ByVal Pointer As String)
    Private Declare Sub StartGen Lib "FGULink.dll " ()
    Private Declare Sub StopGen Lib "FGULink.dll " ()
    Private Declare Sub OpenGen Lib "FGULink.dll " ()
    Private Declare Sub CloseGen Lib "FGULink.dll " ()
    Private Declare Function GenReady Lib "FGULink.dll " () As Boolean
    Private Declare Function GenStatus Lib "FGULink.dll " () As Integer
    Private Declare Sub ShowGen Lib "FGULink.dll " (ByVal status As Boolean)
    Private Declare Sub AttOn Lib "FGULink.dll " (ByVal att As Boolean)
    Private Declare Sub LogSweep Lib "FGULink.dll " (ByVal log As Boolean)
    Dim Wave As Integer

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        OpenGen()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        CloseGen()
    End Sub

    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        CloseGen()
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        LogSweep(CheckBox1.Checked)
    End Sub

    Private Sub CheckBox3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox3.CheckedChanged
        ShowGen(Not CheckBox3.Checked)
    End Sub

    Private Sub CheckBox4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox4.CheckedChanged
        AttOn(CheckBox4.Checked)
    End Sub

    Private Sub CheckBox5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox5.CheckedChanged
        If Wave = 4 Then StopGen()
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If GenReady() Then Label1.Text = "Generator Ready" Else Label1.Text = "Generator Not Ready"
        Label2.Text = "Status: " & GenStatus()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        SetGen(1, CSng(TextBox1.Text), CSng(TextBox2.Text), CSng(TextBox3.Text))
        StartGen()
        Wave = 1
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        SetGen(2, CSng(TextBox1.Text), CSng(TextBox2.Text), CSng(TextBox3.Text))
        StartGen()
        Wave = 2
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        SetGen(3, CSng(TextBox1.Text), CSng(TextBox2.Text), CSng(TextBox3.Text))
        StartGen()
        Wave = 3
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Dim Filter As Integer
        If CheckBox5.Checked Then Filter = 1 Else Filter = 0
        SetLibWave(CSng(TextBox1.Text), CSng(TextBox2.Text), CSng(TextBox3.Text), Filter, TextBox4.Text)
        StartGen()
        Wave = 4
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Dim Form As Integer
        If CheckBox2.Checked Then Form = 2 Else Form = 1
        SetSweep(CSng(TextBox5.Text), CSng(TextBox6.Text), CSng(TextBox2.Text), CSng(TextBox3.Text), CSng(TextBox7.Text), Form)
        StartGen()
        Wave = 5
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        StopGen()
    End Sub
End Class
