unit FG_Test1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;


type
  TForm1 = class(TForm)
    Button1: TButton;
    Button3: TButton;
    Button4: TButton;
    Label1: TLabel;
    Button5: TButton;
    Timer1: TTimer;
    Label2: TLabel;
    Button8: TButton;
    Button9: TButton;
    Button11: TButton;
    Button2: TButton;
    Button6: TButton;
    Button7: TButton;
    Label3: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;

    procedure Button1Click(Sender: TObject);    
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  s:string;

implementation

{$R *.DFM}

{DLL procedures and functions}
procedure StartGen; stdcall; external 'FGULink.dll';
procedure StopGen; stdcall; external 'FGULink.dll';
procedure OpenGen; stdcall; external 'FGULink.dll';
procedure CloseGen; stdcall; external 'FGULink.dll';
procedure ShowGen(status: Boolean); stdcall; external 'FGULink.dll';
function GenStatus: Longint; external 'FGULink.dll';
function GenReady: Boolean; stdcall; external 'FGULink.dll';
procedure AttOn(att: Boolean) ; stdcall; external 'FGULink.dll';
procedure LogSweep(log: Boolean) ; stdcall; external 'FGULink.dll';
procedure SetGen(func: Longint; freq, ampl, offset: Single) ; stdcall; external 'FGULink.dll';
procedure SetSweep(freq1, freq2, ampl, offset, time: Single; form: Longint); stdcall; external 'FGULink.dll';
procedure SetLibWave(freq, ampl, offset: Single; filter: Longint; FileName:PChar); stdcall; external 'FGULink.dll';

procedure TForm1.Button1Click(Sender: TObject);
begin
  StartGen;
  Label1.caption:='Generator Started';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  StopGen;
  Label1.caption:='Generator Stopped';
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 SetGen(1, 1000, 5, 0);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 SetGen(3, 1000, 5, 0);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if GenReady then
  begin
    label2.caption:='Generator Ready!';     
  end
  else
  begin
    label2.caption:='Generator Not Ready';
  end;
    label3.caption:='Status: '+inttostr(GenStatus);
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  SetGen(2, 1500, 5, 0);
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  LogSweep(true);
  SetSweep(10, 2000000, 5, 0, 50, 1);
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  s:='ramp_dn.lib';
  SetLibWave(1000, 5, 2.5, 1, PChar(s));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  LogSweep(false);
  SetSweep(1000, 10000, 5, 0, 10, 2);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 OpenGen;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  CloseGen;
  Label1.caption:='';
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  CloseGen;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.checked then AttOn(True) else AttOn(False);
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  SetGen(1, 500, 5, 0);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  ShowGen(not CheckBox2.checked);
end;

end.
