VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "FGULink.DLL Demo"
   ClientHeight    =   6390
   ClientLeft      =   315
   ClientTop       =   480
   ClientWidth     =   4215
   LinkTopic       =   "Form1"
   ScaleHeight     =   6390
   ScaleWidth      =   4215
   Begin VB.CheckBox Check2 
      Caption         =   "Hide Generator"
      Height          =   255
      Left            =   2520
      TabIndex        =   12
      Top             =   5760
      Width           =   1575
   End
   Begin VB.CheckBox Check1 
      Caption         =   "40dB Attenuator On"
      Height          =   255
      Left            =   240
      TabIndex        =   10
      Top             =   5760
      Width           =   1935
   End
   Begin VB.CommandButton Command6 
      Caption         =   "Turn Off Generator"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   2280
      TabIndex        =   9
      Top             =   120
      Width           =   1815
   End
   Begin VB.CommandButton Command5 
      Caption         =   "Turn On Generator"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   8
      Top             =   120
      Width           =   1815
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Sweep, Lin, 1k-20kHz, 5Vpp, 0Voff, 10sec, Sqr."
      Height          =   435
      Left            =   120
      TabIndex        =   7
      Top             =   2940
      Width           =   3975
   End
   Begin VB.CommandButton Sweep 
      Caption         =   "Sweep, Log, 100Hz-20kHz, 5Vpp, 0Voff, 5sec, Sin"
      Height          =   435
      Left            =   120
      TabIndex        =   6
      Top             =   2400
      Width           =   3975
   End
   Begin VB.CommandButton Lib 
      Caption         =   "Lib 'burst2.lib' 1kHz, 5Vpp, 0Voff, filter ON "
      Height          =   435
      Left            =   120
      TabIndex        =   5
      Top             =   3480
      Width           =   3975
   End
   Begin VB.Timer Timer1 
      Interval        =   100
      Left            =   3600
      Top             =   4200
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Tri, 1kHz, 5Vpp, 0Voff"
      Height          =   435
      Left            =   120
      TabIndex        =   3
      Top             =   1860
      Width           =   3975
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Sine, 150Hz, 8.5Vpp, 0.1Voff"
      Height          =   435
      Left            =   120
      TabIndex        =   2
      Top             =   780
      Width           =   3975
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Sqr, 1.5kHz, 6.5Vpp, 2V offs."
      Height          =   435
      Left            =   120
      TabIndex        =   1
      Top             =   1320
      Width           =   3975
   End
   Begin VB.CommandButton Stop 
      Caption         =   "Stop"
      Height          =   375
      Index           =   1
      Left            =   120
      TabIndex        =   0
      Top             =   4920
      Width           =   1455
   End
   Begin VB.Label Label2 
      Caption         =   "- - -"
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   4440
      Width           =   3015
   End
   Begin VB.Label Label1 
      Caption         =   "- - -"
      Height          =   195
      Left            =   120
      TabIndex        =   4
      Top             =   4140
      Width           =   3135
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Sub SetGen Lib "FGULink.dll " (ByVal func As Long, ByVal freq As Single, ByVal ampl As Single, ByVal offset As Single)
Private Declare Sub SetSweep Lib "FGULink.dll " (ByVal freq1 As Single, ByVal freq2 As Single, ByVal ampl As Single, ByVal offset As Single, ByVal time As Single, ByVal Form As Long)
Private Declare Sub SetLibWave Lib "FGULink.dll " (ByVal freq As Single, ByVal ampl As Single, ByVal offset As Single, ByVal filter As Long, ByVal Pointer As String)
Private Declare Sub StartGen Lib "FGULink.dll " ()
Private Declare Sub StopGen Lib "FGULink.dll " ()
Private Declare Sub OpenGen Lib "FGULink.dll " ()
Private Declare Sub CloseGen Lib "FGULink.dll " ()
Private Declare Function GenReady Lib "FGULink.dll " () As Boolean
Private Declare Function GenStatus Lib "FGULink.dll " () As Long
Private Declare Sub ShowGen Lib "FGULink.dll " (ByVal status As Boolean)
Private Declare Sub AttOn Lib "FGULink.dll " (ByVal att As Boolean)
Private Declare Sub LogSweep Lib "FGULink.dll " (ByVal log As Boolean)

Private Sub Form_Terminate()
    CloseGen
End Sub

Private Sub Command5_Click()
    OpenGen
End Sub

Private Sub Command6_Click()
    CloseGen
End Sub

Private Sub Command2_Click()
    SetGen 1, 150, 8.5, 0.1
    StartGen
End Sub

Private Sub Command1_Click()
    SetGen 2, 1500, 6.5, 2
    StartGen
End Sub

Private Sub Command3_Click()
    SetGen 3, 1000, 5, 0
    StartGen
End Sub

Private Sub Lib_Click()
    Dim s As String
    s = "burst2.lib"
    SetLibWave 1000, 5, 0, 1, s
    StartGen
End Sub

Private Sub Sweep_Click()
    LogSweep (True)
    SetSweep 100, 20000, 5, 0, 5, 1
    StartGen
End Sub

Private Sub Command4_Click()
    LogSweep (False)
    SetSweep 1000, 20000, 5, 0, 10, 2
    StartGen
End Sub

Private Sub Run_Click(Index As Integer)
    StartGen
End Sub

Private Sub Stop_Click(Index As Integer)
    StopGen
End Sub

Private Sub Check1_Click()
    If Check1.Value = 1 Then AttOn (True) Else AttOn (False)
End Sub

Private Sub Check2_Click()
    If Check2.Value = 1 Then ShowGen (False) Else ShowGen (True)
End Sub

Private Sub Timer1_Timer()
    If GenReady Then Label1.Caption = "Generator Ready" _
    Else: Label1.Caption = "Generator Not Ready"
    Label2.Caption = "Status: " & GenStatus
End Sub
